<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_klarna_kco/classes/constants.php';

global $kco_order, $page;

if($page->page_name == 'checkout' && $page->page_action == 'process')
{
    try {
        /**
         * native kco order / TODO stimmt nicht, die kco_order_id haben wir immmer
         */
        if(!empty($_SESSION['kco_order_id']) && $_GET['kco_order_id'] && $_SESSION['kco_order_id'] == $_GET['kco_order_id'])
        {
            /**
             * retrieve klarna order
             */

            $kco_order = klarna_kco::getCheckoutOrder($_GET['kco_order_id']);

            /**
             *  register / login customer
             */
            $xt_kco = new xt_klarna_kco();
            $xt_kco->checkLoginCustomer($kco_order);


            /**
             *  adressen aus klarna holen
             *  - test ob billing/shipping identisch
             *  - prüfen ob klarna adressen in xt existieren > ggf hinzufügen
             *  - adressen dem session customer hinzufügen
             *
             */
            $sessionCustomer = sessionCustomer();

            /** check billing address exists in xt or not, create new if necessary */
            $klarna_address_as_xt = $xt_kco->checkAddAddress($kco_order['billing_address'], $sessionCustomer, $kco_order['customer']['date_of_birth'], 'default');

            $_SESSION['customer']->customer_default_address =
            $_SESSION['customer']->customer_payment_address =
            $_SESSION['customer']->customer_shipping_address = $klarna_address_as_xt;

            /** check klarna billing and shipping are same */
            $addressIgnoreKeys = array(
                'region' // klarna's shipping address does not provide region for shipping address !?
            );
            $shippingSame = klarna_kco::compareAddresses($kco_order['billing_address'], $kco_order['shipping_address'], $addressIgnoreKeys);
            if(!$shippingSame)
            {
                $klarna_address_as_xt = $xt_kco->checkAddAddress($kco_order['shipping_address'], $sessionCustomer, $kco_order['customer']['date_of_birth'], 'shipping');
                $_SESSION['customer']->customer_shipping_address = $klarna_address_as_xt;
            }

            /**
             * prepare data for checkout.php > POST action case 'process'
             * set shipping / payment / addresses
             */
            if(isset($_GET['selected_payment']) && !empty($_GET['selected_payment']))
            {
                $_POST['selected_payment'] = $_GET['selected_payment'];
                $_POST['action'] = 'payment';
                $_SESSION['selected_shipping'] = $kco_order['selected_shipping_option']['id'];
                $_POST['comments'] = $_SESSION['order_comments'];

                unset($kco_order); /** in case its an external/xt payment method */
                unset($_SESSION['kco_order_id']);
            }
            else
            {
                $_SESSION['selected_payment'] = 'klarna_kco';
                $_POST['action'] = 'process';
                $_POST['withdrawal_reject_accepted'] = $_POST['rescission_accepted'] = $_POST['conditions_accepted'] = 'on';
                $_SESSION['selected_shipping'] = $kco_order['selected_shipping_option']['id'];
            }

        }
        else {
            echo $_SESSION['kco_order_id']. '_'. $_GET['kco_order_id'] ;
            die(8);
        }
    }
    catch(Exception $e)
    {
        error_log($e->getMessage());
    }
}